Index: palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- palm/trunk/SOURCE/salsa_mod.f90	(revision 4130)
+++ palm/trunk/SOURCE/salsa_mod.f90	(revision 4131)
@@ -26,4 +26,15 @@
 ! -----------------
 ! $Id$
+! - Add "salsa_" before each salsa output variable
+! - Add a possibility to output the number (salsa_N_UFP) and mass concentration
+!   (salsa_PM0.1) of ultrafine particles, i.e. particles with a diameter smaller
+!   than 100 nm
+! - Implement aerosol emission mode "parameterized" which is based on the street
+!   type (similar to the chemistry module).
+! - Remove unnecessary nucleation subroutines.
+! - Add the z-dimension for gaseous emissions to correspond the implementation
+!   in the chemistry module
+! 
+! 4118 2019-07-25 16:11:45Z suehring
 ! - When Dirichlet condition is applied in decycling, the boundary conditions are
 !   only set at the ghost points and not at the prognostic grid points as done
@@ -211,7 +222,8 @@
                bc_lr, bc_lr_cyc, bc_ns, bc_ns_cyc, bc_radiation_l, bc_radiation_n, bc_radiation_r, &
                bc_radiation_s, coupling_char, debug_output, dt_3d, intermediate_timestep_count,    &
-               intermediate_timestep_count_max, land_surface, message_string, monotonic_limiter_z, &
-               plant_canopy, pt_surface, salsa, scalar_advec, surface_pressure,                    &
-               time_since_reference_point, timestep_scheme, tsc, urban_surface, ws_scheme_sca
+               intermediate_timestep_count_max, land_surface, max_pr_salsa, message_string,        &
+               monotonic_limiter_z, plant_canopy, pt_surface, salsa, scalar_advec,                 &
+               surface_pressure, time_since_reference_point, timestep_scheme, tsc, urban_surface,  &
+               ws_scheme_sca
 
     USE indices,                                                                                   &
@@ -392,4 +404,6 @@
                                             !< 1 = read vertical profile from an input file
     INTEGER(iwp) ::  lod_gas_emissions = 0  !< level of detail of the gaseous emission data
+    INTEGER(iwp) ::  main_street_id = 0     !< lower bound of main street IDs (OpenStreetMaps) for parameterized mode
+    INTEGER(iwp) ::  max_street_id = 0      !< upper bound of main street IDs (OpenStreetMaps) for parameterized mode
     INTEGER(iwp) ::  nbins_aerosol = 1      !< total number of size bins
     INTEGER(iwp) ::  ncc   = 1              !< number of chemical components used
@@ -413,4 +427,6 @@
                                             !< 9 = homomolecular nucleation of H2SO4 and ORG
                                             !<     + heteromolecular nucleation with H2SO4*ORG
+    INTEGER(iwp) ::  salsa_pr_count = 0     !< counter for salsa variable profiles
+    INTEGER(iwp) ::  side_street_id = 0     !< lower bound of side street IDs (OpenStreetMaps) for parameterized mode
     INTEGER(iwp) ::  start_subrange_1a = 1  !< start index for bin subranges: subrange 1a
     INTEGER(iwp) ::  start_subrange_2a = 1  !<                                subrange 2a
@@ -419,8 +435,9 @@
     INTEGER(iwp), DIMENSION(nreg) ::  nbin = (/ 3, 7/)  !< Number of size bins per subrange: 1 & 2
 
-    INTEGER(iwp), DIMENSION(ngases_salsa) ::  gas_index_chem = &
-                                                 (/ 1, 1, 1, 1, 1/)  !< gas indices in chemistry_model_mod
-                                                 !< 1 = H2SO4, 2 = HNO3, 3 = NH3, 4 = OCNV, 5 = OCSV
+    INTEGER(iwp), DIMENSION(ngases_salsa) ::  gas_index_chem = (/ 1, 1, 1, 1, 1/)  !< gas indices in chemistry_model_mod
+                                                                                   !< 1 = H2SO4, 2 = HNO3,
+                                                                                   !< 3 = NH3,   4 = OCNV, 5 = OCSV
     INTEGER(iwp), DIMENSION(ngases_salsa) ::  emission_index_chem  !< gas indices in the gas emission file
+    INTEGER(iwp), DIMENSION(99) ::  salsa_pr_index  = 0            !< index for salsa profiles
 
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  k_topo_top  !< vertical index of the topography top
@@ -466,6 +483,8 @@
     LOGICAL ::  lspartition  = .FALSE.  !< Partition of HNO3 and NH3
 
-    REAL(wp) ::  act_coeff = 1.0E-7_wp               !< Activation coefficient
+    REAL(wp) ::  act_coeff = 1.0E-7_wp               !< Activation coefficient (1/s)
     REAL(wp) ::  dt_salsa  = 0.00001_wp              !< Time step of SALSA
+    REAL(wp) ::  emiss_factor_main = 0.0_wp          !< relative emission factor for main streets
+    REAL(wp) ::  emiss_factor_side = 0.0_wp          !< relative emission factor for side streets
     REAL(wp) ::  h2so4_init = nclim                  !< Init value for sulphuric acid gas
     REAL(wp) ::  hno3_init  = nclim                  !< Init value for nitric acid gas
@@ -557,5 +576,5 @@
        INTEGER(iwp) ::  tind               !< time index for reference time in salsa emission data
 
-       INTEGER(iwp), DIMENSION(maxspec) ::  cc_input_to_model   !<
+       INTEGER(iwp), DIMENSION(maxspec) ::  cc_in2mod = 0   !<
 
        INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  cat_index  !< Index of emission categories
@@ -630,17 +649,17 @@
     TYPE salsa_variable
 
-       REAL(wp), ALLOCATABLE, DIMENSION(:)     ::  init  !<
-
-       REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::  diss_s     !<
-       REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::  flux_s     !<
-       REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::  source     !<
-       REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::  sums_ws_l  !<
-
-       REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::  diss_l  !<
-       REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::  flux_l  !<
-
-       REAL(wp), POINTER, DIMENSION(:,:,:), CONTIGUOUS ::  conc     !<
-       REAL(wp), POINTER, DIMENSION(:,:,:), CONTIGUOUS ::  conc_p   !<
-       REAL(wp), POINTER, DIMENSION(:,:,:), CONTIGUOUS ::  tconc_m  !<
+       REAL(wp), DIMENSION(:), ALLOCATABLE     ::  init  !<
+
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s     !<
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s     !<
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  source     !<
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_ws_l  !<
+
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l  !<
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l  !<
+
+       REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  conc     !<
+       REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  conc_p   !<
+       REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  tconc_m  !<
 
     END TYPE salsa_variable
@@ -673,5 +692,6 @@
 
     TYPE(chem_emis_att_type) ::  chem_emission_att  !< chemistry emission attributes
-    TYPE(chem_emis_val_type) ::  chem_emission      !< chemistry emission values
+
+    TYPE(chem_emis_val_type), DIMENSION(:), ALLOCATABLE ::  chem_emission  !< chemistry emissions
 
     TYPE(t_section), DIMENSION(:), ALLOCATABLE ::  aero  !< local aerosol properties
@@ -683,5 +703,5 @@
     TYPE(match_surface), DIMENSION(0:3) ::  usm_to_depo_v  !< to match the deposition mod. and vertical USM surfaces
 !
-!-- SALSA variables: as x = x(k,j,i,bin). 
+!-- SALSA variables: as x = x(k,j,i,bin).
 !-- The 4th dimension contains all the size bins sequentially for each aerosol species  + water.
 !
@@ -689,24 +709,24 @@
 !
 !-- Number concentration (#/m3)
-    TYPE(salsa_variable), ALLOCATABLE, DIMENSION(:), TARGET ::  aerosol_number  !<
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  nconc_1  !<
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  nconc_2  !<
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  nconc_3  !<
+    TYPE(salsa_variable), DIMENSION(:), ALLOCATABLE, TARGET ::  aerosol_number  !<
+    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  nconc_1  !<
+    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  nconc_2  !<
+    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  nconc_3  !<
 !
 !-- Mass concentration (kg/m3)
-    TYPE(salsa_variable), ALLOCATABLE, DIMENSION(:), TARGET ::  aerosol_mass  !<
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  mconc_1  !<
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  mconc_2  !<
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  mconc_3  !<
+    TYPE(salsa_variable), DIMENSION(:), ALLOCATABLE, TARGET ::  aerosol_mass  !<
+    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  mconc_1  !<
+    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  mconc_2  !<
+    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  mconc_3  !<
 !
 !-- Gaseous concentrations (#/m3)
-    TYPE(salsa_variable), ALLOCATABLE, DIMENSION(:), TARGET ::  salsa_gas  !<
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  gconc_1  !<
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  gconc_2  !<
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  gconc_3  !<
+    TYPE(salsa_variable), DIMENSION(:), ALLOCATABLE, TARGET ::  salsa_gas  !<
+    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  gconc_1  !<
+    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  gconc_2  !<
+    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  gconc_3  !<
 !
 !-- Diagnostic tracers
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:) ::  sedim_vd  !< sedimentation velocity per bin (m/s)
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:) ::  ra_dry    !< aerosol dry radius (m)
+    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  sedim_vd  !< sedimentation velocity per bin (m/s)
+    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  ra_dry    !< aerosol dry radius (m)
 
 !-- Particle component index tables
@@ -717,142 +737,135 @@
 !
 !-- Gases:
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  g_h2so4_av  !< H2SO4
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  g_hno3_av   !< HNO3
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  g_nh3_av    !< NH3
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  g_ocnv_av   !< non-volatile OC
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  g_ocsv_av   !< semi-volatile OC
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  g_h2so4_av  !< H2SO4
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  g_hno3_av   !< HNO3
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  g_nh3_av    !< NH3
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  g_ocnv_av   !< non-volatile OC
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  g_ocsv_av   !< semi-volatile OC
 !
 !-- Integrated:
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  ldsa_av  !< lung-deposited surface area
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  ntot_av  !< total number concentration
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  pm25_av  !< PM2.5
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  pm10_av  !< PM10
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ldsa_av  !< lung-deposited surface area
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ntot_av  !< total number concentration
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nufp_av  !< ultrafine particles (UFP)
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  pm01_av  !< PM0.1
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  pm25_av  !< PM2.5
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  pm10_av  !< PM10
 !
 !-- In the particle phase:
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  s_bc_av   !< black carbon
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  s_du_av   !< dust
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  s_h2o_av  !< liquid water
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  s_nh_av   !< ammonia
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  s_no_av   !< nitrates
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  s_oc_av   !< org. carbon
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  s_so4_av  !< sulphates
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  s_ss_av   !< sea salt
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  s_bc_av   !< black carbon
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  s_du_av   !< dust
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  s_h2o_av  !< liquid water
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  s_nh_av   !< ammonia
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  s_no_av   !< nitrates
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  s_oc_av   !< org. carbon
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  s_so4_av  !< sulphates
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  s_ss_av   !< sea salt
 !
 !-- Bin specific mass and number concentrations:
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  mbins_av  !< bin mas
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  nbins_av  !< bin number
+    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  mbins_av  !< bin mas
+    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  nbins_av  !< bin number
 
 !
 !-- PALM interfaces:
-!
-!-- Boundary conditions:
+
+    INTERFACE salsa_actions
+       MODULE PROCEDURE salsa_actions
+       MODULE PROCEDURE salsa_actions_ij
+    END INTERFACE salsa_actions
+
+    INTERFACE salsa_3d_data_averaging
+       MODULE PROCEDURE salsa_3d_data_averaging
+    END INTERFACE salsa_3d_data_averaging
+
     INTERFACE salsa_boundary_conds
        MODULE PROCEDURE salsa_boundary_conds
        MODULE PROCEDURE salsa_boundary_conds_decycle
     END INTERFACE salsa_boundary_conds
-!
-!-- Data output checks for 2D/3D data to be done in check_parameters
+
     INTERFACE salsa_check_data_output
        MODULE PROCEDURE salsa_check_data_output
     END INTERFACE salsa_check_data_output
-!
-!-- Input parameter checks to be done in check_parameters
+
+    INTERFACE salsa_check_data_output_pr
+       MODULE PROCEDURE salsa_check_data_output_pr
+    END INTERFACE salsa_check_data_output_pr
+
     INTERFACE salsa_check_parameters
        MODULE PROCEDURE salsa_check_parameters
     END INTERFACE salsa_check_parameters
-!
-!-- Averaging of 3D data for output
-    INTERFACE salsa_3d_data_averaging
-       MODULE PROCEDURE salsa_3d_data_averaging
-    END INTERFACE salsa_3d_data_averaging
-!
-!-- Data output of 2D quantities
+
     INTERFACE salsa_data_output_2d
        MODULE PROCEDURE salsa_data_output_2d
     END INTERFACE salsa_data_output_2d
-!
-!-- Data output of 3D data
+
     INTERFACE salsa_data_output_3d
        MODULE PROCEDURE salsa_data_output_3d
     END INTERFACE salsa_data_output_3d
-!
-!-- Data output of 3D data
+
     INTERFACE salsa_data_output_mask
        MODULE PROCEDURE salsa_data_output_mask
     END INTERFACE salsa_data_output_mask
-!
-!-- Definition of data output quantities
+
     INTERFACE salsa_define_netcdf_grid
        MODULE PROCEDURE salsa_define_netcdf_grid
     END INTERFACE salsa_define_netcdf_grid
-!
-!-- Output of information to the header file
+
+    INTERFACE salsa_driver
+       MODULE PROCEDURE salsa_driver
+    END INTERFACE salsa_driver
+
+    INTERFACE salsa_emission_update
+       MODULE PROCEDURE salsa_emission_update
+    END INTERFACE salsa_emission_update
+
+    INTERFACE salsa_exchange_horiz_bounds
+       MODULE PROCEDURE salsa_exchange_horiz_bounds
+    END INTERFACE salsa_exchange_horiz_bounds
+
     INTERFACE salsa_header
        MODULE PROCEDURE salsa_header
     END INTERFACE salsa_header
-!
-!-- Initialization actions
+
     INTERFACE salsa_init
        MODULE PROCEDURE salsa_init
     END INTERFACE salsa_init
-!
-!-- Initialization of arrays
+
     INTERFACE salsa_init_arrays
        MODULE PROCEDURE salsa_init_arrays
     END INTERFACE salsa_init_arrays
-!
-!-- Writing of binary output for restart runs  !!! renaming?!
-    INTERFACE salsa_wrd_local
-       MODULE PROCEDURE salsa_wrd_local
-    END INTERFACE salsa_wrd_local
-!
-!-- Reading of NAMELIST parameters
-    INTERFACE salsa_parin
-       MODULE PROCEDURE salsa_parin
-    END INTERFACE salsa_parin
-!
-!-- Reading of parameters for restart runs
-    INTERFACE salsa_rrd_local
-       MODULE PROCEDURE salsa_rrd_local
-    END INTERFACE salsa_rrd_local
-!
-!-- Swapping of time levels (required for prognostic variables)
-    INTERFACE salsa_swap_timelevel
-       MODULE PROCEDURE salsa_swap_timelevel
-    END INTERFACE salsa_swap_timelevel
-!
-!-- Interface between PALM and salsa
-    INTERFACE salsa_driver
-       MODULE PROCEDURE salsa_driver
-    END INTERFACE salsa_driver
-
-!-- Actions salsa variables
-    INTERFACE salsa_actions
-       MODULE PROCEDURE salsa_actions
-       MODULE PROCEDURE salsa_actions_ij
-    END INTERFACE salsa_actions
-!
-!-- Non-advective processes (i.e. aerosol dynamic reactions) for salsa variables
+
     INTERFACE salsa_non_advective_processes
        MODULE PROCEDURE salsa_non_advective_processes
        MODULE PROCEDURE salsa_non_advective_processes_ij
     END INTERFACE salsa_non_advective_processes
-!
-!-- Exchange horiz for salsa variables
-    INTERFACE salsa_exchange_horiz_bounds
-       MODULE PROCEDURE salsa_exchange_horiz_bounds
-    END INTERFACE salsa_exchange_horiz_bounds
-!
-!-- Prognostics equations for salsa variables
+
+    INTERFACE salsa_parin
+       MODULE PROCEDURE salsa_parin
+    END INTERFACE salsa_parin
+
     INTERFACE salsa_prognostic_equations
        MODULE PROCEDURE salsa_prognostic_equations
        MODULE PROCEDURE salsa_prognostic_equations_ij
     END INTERFACE salsa_prognostic_equations
-!
-!-- Tendency salsa variables
+
+    INTERFACE salsa_rrd_local
+       MODULE PROCEDURE salsa_rrd_local
+    END INTERFACE salsa_rrd_local
+
+    INTERFACE salsa_statistics
+       MODULE PROCEDURE salsa_statistics
+    END INTERFACE salsa_statistics
+
+    INTERFACE salsa_swap_timelevel
+       MODULE PROCEDURE salsa_swap_timelevel
+    END INTERFACE salsa_swap_timelevel
+
     INTERFACE salsa_tendency
        MODULE PROCEDURE salsa_tendency
        MODULE PROCEDURE salsa_tendency_ij
     END INTERFACE salsa_tendency
+
+    INTERFACE salsa_wrd_local
+       MODULE PROCEDURE salsa_wrd_local
+    END INTERFACE salsa_wrd_local
 
 
@@ -867,5 +880,6 @@
            salsa_emission_update, salsa_header, salsa_init, salsa_init_arrays, salsa_parin,        &
            salsa_rrd_local, salsa_swap_timelevel, salsa_prognostic_equations, salsa_wrd_local,     &
-           salsa_actions, salsa_non_advective_processes, salsa_exchange_horiz_bounds
+           salsa_actions, salsa_non_advective_processes, salsa_exchange_horiz_bounds,              &
+           salsa_check_data_output_pr, salsa_statistics
 !
 !-- Public parameters, constants and initial values
@@ -888,22 +902,68 @@
  SUBROUTINE salsa_parin
 
+    USE control_parameters,                                                                        &
+        ONLY:  data_output_pr
+
     IMPLICIT NONE
 
-    CHARACTER(LEN=80) ::  line   !< dummy string that contains the current line
-                                  !< of the parameter file
-
-    NAMELIST /salsa_parameters/      aerosol_flux_dpg, aerosol_flux_mass_fracs_a,                  &
-                                     aerosol_flux_mass_fracs_b, aerosol_flux_sigmag,               &
-                                     advect_particle_water, bc_salsa_b, bc_salsa_t,                &
-                                     decycle_salsa_lr, decycle_method_salsa, decycle_salsa_ns,     &
-                                     depo_pcm_par, depo_pcm_type,                                  &
-                                     depo_surf_par, dpg, dt_salsa, feedback_to_palm, h2so4_init,   &
-                                     hno3_init, init_gases_type, init_aerosol_type, listspec,      &
-                                     mass_fracs_a, mass_fracs_b, n_lognorm, nbin, nest_salsa, nf2a,&
-                                     nh3_init, nj3, nlcnd, nlcndgas, nlcndh2oae, nlcoag, nldepo,   &
-                                     nldepo_pcm,  nldepo_surf, nldistupdate, nsnucl, ocnv_init,    &
-                                     ocsv_init, read_restart_data_salsa, reglim, salsa,            &
-                                     salsa_emission_mode, sigmag, skip_time_do_salsa,              &
-                                     surface_aerosol_flux, van_der_waals_coagc, write_binary_salsa
+    CHARACTER(LEN=80) ::  line   !< dummy string that contains the current line of parameter file
+
+    INTEGER(iwp) ::  i                 !< loop index
+    INTEGER(iwp) ::  max_pr_salsa_tmp  !< dummy variable
+
+    NAMELIST /salsa_parameters/      aerosol_flux_dpg,                         &
+                                     aerosol_flux_mass_fracs_a,                &
+                                     aerosol_flux_mass_fracs_b,                &
+                                     aerosol_flux_sigmag,                      &
+                                     advect_particle_water,                    &
+                                     bc_salsa_b,                               &
+                                     bc_salsa_t,                               &
+                                     decycle_salsa_lr,                         &
+                                     decycle_method_salsa,                     &
+                                     decycle_salsa_ns,                         &
+                                     depo_pcm_par,                             &
+                                     depo_pcm_type,                            &
+                                     depo_surf_par,                            &
+                                     dpg,                                      &
+                                     dt_salsa,                                 &
+                                     emiss_factor_main,                        &
+                                     emiss_factor_side,                        &
+                                     feedback_to_palm,                         &
+                                     h2so4_init,                               &
+                                     hno3_init,                                &
+                                     init_gases_type,                          &
+                                     init_aerosol_type,                        &
+                                     listspec,                                 &
+                                     main_street_id,                           &
+                                     mass_fracs_a,                             &
+                                     mass_fracs_b,                             &
+                                     max_street_id,                            &
+                                     n_lognorm,                                &
+                                     nbin,                                     &
+                                     nest_salsa,                               &
+                                     nf2a,                                     &
+                                     nh3_init,                                 &
+                                     nj3,                                      &
+                                     nlcnd,                                    &
+                                     nlcndgas,                                 &
+                                     nlcndh2oae,                               &
+                                     nlcoag,                                   &
+                                     nldepo,                                   &
+                                     nldepo_pcm,                               &
+                                     nldepo_surf,                              &
+                                     nldistupdate,                             &
+                                     nsnucl,                                   &
+                                     ocnv_init,                                &
+                                     ocsv_init,                                &
+                                     read_restart_data_salsa,                  &
+                                     reglim,                                   &
+                                     salsa,                                    &
+                                     salsa_emission_mode,                      &
+                                     sigmag,                                   &
+                                     side_street_id,                           &
+                                     skip_time_do_salsa,                       &
+                                     surface_aerosol_flux,                     &
+                                     van_der_waals_coagc,                      &
+                                     write_binary_salsa
 
     line = ' '
@@ -924,4 +984,13 @@
 
  10 CONTINUE
+!
+!-- Update the number of output profiles
+    max_pr_salsa_tmp = 0
+    i = 1
+    DO WHILE ( data_output_pr(i) /= ' '  .AND.  i <= 100 )
+       IF ( TRIM( data_output_pr(i)(1:6) ) == 'salsa_' )  max_pr_salsa_tmp = max_pr_salsa_tmp + 1
+       i = i + 1
+    ENDDO
+    IF ( max_pr_salsa_tmp > 0 )  max_pr_salsa = max_pr_salsa_tmp
 
  END SUBROUTINE salsa_parin
@@ -1003,29 +1072,5 @@
 !-- Check for the grid
 
-    IF ( var(1:2) == 'g_' )  THEN
-       grid_x = 'x'
-       grid_y = 'y'
-       grid_z = 'zu'
-    ELSEIF ( var(1:4) == 'LDSA' )  THEN
-       grid_x = 'x'
-       grid_y = 'y'
-       grid_z = 'zu'
-    ELSEIF ( var(1:5) == 'm_bin' )  THEN
-       grid_x = 'x'
-       grid_y = 'y'
-       grid_z = 'zu'
-    ELSEIF ( var(1:5) == 'N_bin' )  THEN
-       grid_x = 'x'
-       grid_y = 'y'
-       grid_z = 'zu'
-    ELSEIF ( var(1:4) == 'Ntot' ) THEN
-       grid_x = 'x'
-       grid_y = 'y'
-       grid_z = 'zu'
-    ELSEIF ( var(1:2) == 'PM' )  THEN
-       grid_x = 'x'
-       grid_y = 'y'
-       grid_z = 'zu'
-    ELSEIF ( var(1:2) == 's_' )  THEN
+    IF ( var(1:6) == 'salsa_' )  THEN  ! same grid for all salsa output variables
        grid_x = 'x'
        grid_y = 'y'
@@ -1163,4 +1208,5 @@
     INTEGER(iwp) ::  gases_available !< Number of available gas components in the chemistry model
     INTEGER(iwp) ::  i               !< loop index for allocating
+    INTEGER(iwp) ::  ii              !< index for indexing chemical components
     INTEGER(iwp) ::  l               !< loop index for allocating: surfaces
     INTEGER(iwp) ::  lsp             !< loop index for chem species in the chemistry model
